

datatype mathExp = 
    NUM of int 
  | PLUS of mathExp * mathExp 
  | TIMES of mathExp * mathExp
  | MINUS of mathExp * mathExp
  | DIV of mathExp * mathExp
  | NEG of mathExp

(*
 * calc : mathExp -> int
 * REQUIRES: true
 * ENSURES: calc e ==> the integer e represents or throws a divide by 0 
 *  exception if the expression divides by 0 anywhere
 *)
fun calc (e:mathExp) : int = 
  case e of 
      NUM n => n 
    | PLUS (e1, e2) => (calc e1) + (calc e2)
    | TIMES (e1, e2) => (calc e1) * (calc e2)
    | MINUS (e1, e2) => (calc e1) - (calc e2)
    | DIV (e1, e2) => (calc e1) div (calc e2)
    | NEG e' => ~ (calc e') 