
datatype comparison = EQUAL | GREATER | LESSER


(*
 * compare : int * int -> comparison
 * REQUIRES: true
 * ENSURES: compare (x,y) ==> the corresponding comparison between x and y
 *)
fun compare (x:int, y:int) : comparison = 
  if x > y 
  then GREATER 
  else if x < y 
  then LESSER 
  else EQUAL

val EQUAL = compare (0,0)
val GREATER = compare (1,0)
val LESSER = compare (0,1)



(*
 * oldify : comparison -> int
 * REQUIRES: true
 * ENSURES: oldify EQUAL ==> 0, oldify GREATER ==> 1, oldify LESSER ==> ~1
 *)
fun oldify (c:comparison) : int = 
  case c of 
      EQUAL => 0
    | GREATER => 1 
    | LESSER => ~1

val 0 = oldify EQUAL 
val 1 = oldify GREATER 
val ~1 = oldify LESSER