

datatype intOption = NONE | SOME of int

(*
 * divide : int * int -> intOption
 * REQUIRES: true
 * ENSURES: divide (a,b) ==> SOME c if a div b ==> c, or NONE if b is 0
 *)
fun divide (a:int, b:int) : intOption = 
  if b = 0 
  then NONE 
  else SOME (a div b)

val SOME 3 = divide (6,2)
val NONE = divide (5,0)







(*
 * divOpt : int * int -> intOption
 * REQUIRES: true
 * ENSURES: divOpt (SOME a, SOME b) ==> SOME c if a div b ==> c, otherwise 
 *  divOpt (x, y) ==> NONE
 *)
fun divOpt (p:intOption * intOption) : intOption = 
  (case p of 
      (_, SOME 0) => NONE 
    | (SOME a, SOME b) => SOME (a div b)
    | _ => NONE
  )

val NONE = divOpt (SOME 5, NONE)
val NONE = divOpt (NONE, SOME 3)
val NONE = divOpt (NONE, NONE)
val NONE = divOpt (SOME 1, SOME 0)
val SOME 3 = divOpt (SOME 6, SOME 2)