
datatype comparison = EQUAL | GREATER | LESSER


(*
 * compare : int * int -> comparison
 * REQUIRES: true
 * ENSURES: compare (x,y) ==> the corresponding comparison between x and y
 *)
fun compare (x:int, y:int) : comparison = 
  if x > y 
  then GREATER 
  else if x < y 
  then LESSER 
  else EQUAL

val EQUAL = compare (0,0)
val GREATER = compare (1,0)
val LESSER = compare (0,1)



datatype intTree = LEAF | NODE of int * intTree * intTree


(*
 * depth : intTree -> int
 * REQUIRES: true
 * ENSURES: depth t ==> the depth of t
 *)
fun depth (t:intTree) : int = 
  (case t of 
      LEAF => 0
    | NODE (_, t1, t2) => 
      let 
        val d1 = depth t1 
        val d2 = depth t2 
      in 
        1 + (case compare (d1, d2) of 
          (EQUAL | GREATER) => d1 
          | LESSER => d2
        )
      end
  )